clear all;

rand('state',2);
randn('state',2);

n=100;
dataset=1;
switch dataset
 case 1 % dependent (regression)
  X=(rand(1,n)*2-1)*20;
  Y=randn(1,n)+sin(X/20*pi);
  y_type=0; % regression
  dataname='Regression/Dependent';
 case 2 % independent (regression)
  X=(rand(1,n)*2-1)*20;
  Y=(rand(1,n)*2-1);
  y_type=0; % regression
  dataname='Regression/Independent';
 case 3 % dependent (classification)
  Y=(rand(1,n)>0.5)*2-1;
  X=randn(1,n)+Y;
  y_type=1; % classification
  dataname='Classification/Dependent';
 case 4 % independent (classification)
  Y=(rand(1,n)>0.5)*2-1;
  X=randn(1,n)+((rand(1,n)>0.5)*2-1);
  y_type=1; % classification
  dataname='Classification/Independent';
end

X=X/std(X); % normalization
Y=Y/std(Y);

[pvalue,SMI0,SMI]=LSIT(X,Y,y_type);

figure(1); clf; hold on
set(gca,'FontSize',10)
plot(X,Y,'rx','LineWidth',1,'MarkerSize',10)
xlabel('x')
ylabel('y')
title(sprintf('Data Samples (%s)',dataname))
set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[0 0 8 8]);
print('-dpng',sprintf('LSIT-data%g.png',dataset))

xmin=min([SMI SMI0]);
xmax=max([SMI SMI0]);
xmargin=(xmax-xmin)*0.05;

figure(2); clf; hold on
set(gca,'FontSize',10)
hist(SMI,linspace(xmin,xmax,20))
h = findobj(gca,'Type','patch'); set(h,'FaceColor','y')
plot(SMI0,0,'rx','Linewidth',4,'MarkerSize',20)
title(sprintf('P-value = %0.2f',pvalue))
xlabel('Squared-loss Mutual Information')
set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[0 0 8 4]);
print('-dpng',sprintf('LSIT-SMI%g.png',dataset))
